# apisio_search_api

ApisioSearchApi - JavaScript client for apisio_search_api
This is the API behind the APIs.io search engine.
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: V1
- Package version: V1
- Build package: io.swagger.codegen.v3.generators.javascript.JavaScriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install apisio_search_api --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var ApisioSearchApi = require('apisio_search_api');
var defaultClient = ApisioSearchApi.ApiClient.instance;

// Configure API key authorization: api_key
var api_key = defaultClient.authentications['api_key'];
api_key.apiKey = "YOUR API KEY"
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.apiKeyPrefix['x-api-key'] = "Token"

var api = new ApisioSearchApi.SearchApi()
var body = new ApisioSearchApi.APIsJSON(); // {APIsJSON} 

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.addAPI(body, callback);
```

## Documentation for API Endpoints

All URIs are relative to *https://ibmwu99rx3.execute-api.us-east-1.amazonaws.com/staging*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApisioSearchApi.SearchApi* | [**addAPI**](docs/SearchApi.md#addAPI) | **POST** /search/apis | Submit API
*ApisioSearchApi.SearchApi* | [**searchAPIs**](docs/SearchApi.md#searchAPIs) | **GET** /search/apis | Search APIs
*ApisioSearchApi.SearchApi* | [**searchMaintainers**](docs/SearchApi.md#searchMaintainers) | **GET** /search/maintainers | Search Maintainers

## Documentation for Models

 - [ApisioSearchApi.API](docs/API.md)
 - [ApisioSearchApi.APIsJSON](docs/APIsJSON.md)
 - [ApisioSearchApi.AnyOfSearchDataItems](docs/AnyOfSearchDataItems.md)
 - [ApisioSearchApi.Contact](docs/Contact.md)
 - [ApisioSearchApi.DiagnosticSeverity](docs/DiagnosticSeverity.md)
 - [ApisioSearchApi.Format](docs/Format.md)
 - [ApisioSearchApi.Formats](docs/Formats.md)
 - [ApisioSearchApi.Given](docs/Given.md)
 - [ApisioSearchApi.HumanReadableSeverity](docs/HumanReadableSeverity.md)
 - [ApisioSearchApi.Include](docs/Include.md)
 - [ApisioSearchApi.Latest](docs/Latest.md)
 - [ApisioSearchApi.LatestProperties](docs/LatestProperties.md)
 - [ApisioSearchApi.LatestPropertiesRules](docs/LatestPropertiesRules.md)
 - [ApisioSearchApi.LatestRules](docs/LatestRules.md)
 - [ApisioSearchApi.Maintainer](docs/Maintainer.md)
 - [ApisioSearchApi.MetaInformation](docs/MetaInformation.md)
 - [ApisioSearchApi.PathExpression](docs/PathExpression.md)
 - [ApisioSearchApi.Property](docs/Property.md)
 - [ApisioSearchApi.PublishAPIs](docs/PublishAPIs.md)
 - [ApisioSearchApi.PublishMaintainers](docs/PublishMaintainers.md)
 - [ApisioSearchApi.PublishProperties](docs/PublishProperties.md)
 - [ApisioSearchApi.PublishTags](docs/PublishTags.md)
 - [ApisioSearchApi.Rule](docs/Rule.md)
 - [ApisioSearchApi.Search](docs/Search.md)
 - [ApisioSearchApi.SearchLinks](docs/SearchLinks.md)
 - [ApisioSearchApi.SearchMeta](docs/SearchMeta.md)
 - [ApisioSearchApi.Severity](docs/Severity.md)
 - [ApisioSearchApi.Tag](docs/Tag.md)
 - [ApisioSearchApi.Then](docs/Then.md)
 - [ApisioSearchApi.UpdateMaintainers](docs/UpdateMaintainers.md)
 - [ApisioSearchApi.UpdateProperties](docs/UpdateProperties.md)
 - [ApisioSearchApi.UpdateTags](docs/UpdateTags.md)

## Documentation for Authorization


### api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header

