/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.51
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from "../ApiClient";
import {APIsJSON} from '../model/APIsJSON';
import {Search} from '../model/Search';

/**
* Search service.
* @module api/SearchApi
* @version V1
*/
export class SearchApi {

    /**
    * Constructs a new SearchApi. 
    * @alias module:api/SearchApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the addAPI operation.
     * @callback moduleapi/SearchApi~addAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/APIsJSON{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Submit API
     * Submit an API to be included in the index.
     * @param {module:model/APIsJSON} body 
     * @param {module:api/SearchApi~addAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    addAPI(body, callback) {
      
      let postBody = body;
      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling addAPI");
      }

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['api_key'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = APIsJSON;

      return this.apiClient.callApi(
        '/search/apis', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the searchAPIs operation.
     * @callback moduleapi/SearchApi~searchAPIsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Search{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search APIs
     * Searching across all APIs by keyword, property type, or maintainer.
     * @param {Object} opts Optional parameters
     * @param {String} opts.search Keyword to search by.
     * @param {String} opts.type Type to search by.
     * @param {String} opts.maintainer Maintainer to search by.
     * @param {String} opts.limit 
     * @param {String} opts.page 
     * @param {module:api/SearchApi~searchAPIsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    searchAPIs(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'search': opts['search'],'type': opts['type'],'maintainer': opts['maintainer'],'limit': opts['limit'],'page': opts['page']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = [];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Search;

      return this.apiClient.callApi(
        '/search/apis', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the searchMaintainers operation.
     * @callback moduleapi/SearchApi~searchMaintainersCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Search{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search Maintainers
     * Search across all maintainers.
     * @param {Object} opts Optional parameters
     * @param {String} opts.search Keyword to search by.
     * @param {String} opts.limit 
     * @param {String} opts.page 
     * @param {module:api/SearchApi~searchMaintainersCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    searchMaintainers(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'search': opts['search'],'limit': opts['limit'],'page': opts['page']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = [];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Search;

      return this.apiClient.callApi(
        '/search/maintainers', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}