/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.51
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {Contact} from './Contact';
import {MetaInformation} from './MetaInformation';
import {Property} from './Property';

/**
 * The API model module.
 * @module model/API
 * @version V1
 */
export class API {
  /**
   * Constructs a new <code>API</code>.
   * The description of the API
   * @alias module:model/API
   * @class
   * @param name {String} name
   * @param description {String} description of the API
   * @param image {String} URL of an image representing the API
   * @param baseURL {String} baseURL
   * @param humanURL {String} humanURL
   * @param properties {Array.<module:model/Property>} URLs
   * @param contact {Array.<module:model/Contact>} Contact to reach if questions about API
   */
  constructor(name, description, image, baseURL, humanURL, properties, contact) {
    this.name = name;
    this.description = description;
    this.image = image;
    this.baseURL = baseURL;
    this.humanURL = humanURL;
    this.properties = properties;
    this.contact = contact;
  }

  /**
   * Constructs a <code>API</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/API} obj Optional instance to populate.
   * @return {module:model/API} The populated <code>API</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new API();
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('image'))
        obj.image = ApiClient.convertToType(data['image'], 'String');
      if (data.hasOwnProperty('baseURL'))
        obj.baseURL = ApiClient.convertToType(data['baseURL'], 'String');
      if (data.hasOwnProperty('humanURL'))
        obj.humanURL = ApiClient.convertToType(data['humanURL'], 'String');
      if (data.hasOwnProperty('tags'))
        obj.tags = ApiClient.convertToType(data['tags'], ['String']);
      if (data.hasOwnProperty('properties'))
        obj.properties = ApiClient.convertToType(data['properties'], [Property]);
      if (data.hasOwnProperty('contact'))
        obj.contact = ApiClient.convertToType(data['contact'], [Contact]);
      if (data.hasOwnProperty('meta'))
        obj.meta = ApiClient.convertToType(data['meta'], [MetaInformation]);
    }
    return obj;
  }
}

/**
 * name
 * @member {String} name
 */
API.prototype.name = undefined;

/**
 * description of the API
 * @member {String} description
 */
API.prototype.description = undefined;

/**
 * URL of an image representing the API
 * @member {String} image
 */
API.prototype.image = undefined;

/**
 * baseURL
 * @member {String} baseURL
 */
API.prototype.baseURL = undefined;

/**
 * humanURL
 * @member {String} humanURL
 */
API.prototype.humanURL = undefined;

/**
 * tags to describe the API
 * @member {Array.<String>} tags
 */
API.prototype.tags = undefined;

/**
 * URLs
 * @member {Array.<module:model/Property>} properties
 */
API.prototype.properties = undefined;

/**
 * Contact to reach if questions about API
 * @member {Array.<module:model/Contact>} contact
 */
API.prototype.contact = undefined;

/**
 * @member {Array.<module:model/MetaInformation>} meta
 */
API.prototype.meta = undefined;

// Implement AnyOfSearchDataItems interface:
