/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.51
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {API} from './API';
import {Include} from './Include';
import {Maintainer} from './Maintainer';
import {Tag} from './Tag';

/**
 * The APIsJSON model module.
 * @module model/APIsJSON
 * @version V1
 */
export class APIsJSON {
  /**
   * Constructs a new <code>APIsJSON</code>.
   * @alias module:model/APIsJSON
   * @class
   * @param name {String} The name of the service described
   * @param description {String} Description of the service
   * @param url {String} URL where the apis.json file will live
   */
  constructor(name, description, url) {
    this.name = name;
    this.description = description;
    this.url = url;
  }

  /**
   * Constructs a <code>APIsJSON</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/APIsJSON} obj Optional instance to populate.
   * @return {module:model/APIsJSON} The populated <code>APIsJSON</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new APIsJSON();
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('url'))
        obj.url = ApiClient.convertToType(data['url'], 'String');
      if (data.hasOwnProperty('image'))
        obj.image = ApiClient.convertToType(data['image'], 'String');
      if (data.hasOwnProperty('created'))
        obj.created = ApiClient.convertToType(data['created'], 'Date');
      if (data.hasOwnProperty('modified'))
        obj.modified = ApiClient.convertToType(data['modified'], 'Date');
      if (data.hasOwnProperty('specificationVersion'))
        obj.specificationVersion = ApiClient.convertToType(data['specificationVersion'], 'String');
      if (data.hasOwnProperty('apis'))
        obj.apis = ApiClient.convertToType(data['apis'], [API]);
      if (data.hasOwnProperty('maintainers'))
        obj.maintainers = ApiClient.convertToType(data['maintainers'], [Maintainer]);
      if (data.hasOwnProperty('tags'))
        obj.tags = ApiClient.convertToType(data['tags'], [Tag]);
      if (data.hasOwnProperty('include'))
        obj.include = ApiClient.convertToType(data['include'], [Include]);
    }
    return obj;
  }
}

/**
 * The name of the service described
 * @member {String} name
 */
APIsJSON.prototype.name = undefined;

/**
 * Description of the service
 * @member {String} description
 */
APIsJSON.prototype.description = undefined;

/**
 * URL where the apis.json file will live
 * @member {String} url
 */
APIsJSON.prototype.url = undefined;

/**
 * Image to represent the API
 * @member {String} image
 */
APIsJSON.prototype.image = undefined;

/**
 * Date when the file was created
 * @member {Date} created
 */
APIsJSON.prototype.created = undefined;

/**
 * Date when the file was modified
 * @member {Date} modified
 */
APIsJSON.prototype.modified = undefined;

/**
 * APIs.json spec version, latest is 0.14
 * @member {String} specificationVersion
 */
APIsJSON.prototype.specificationVersion = undefined;

/**
 * All the APIs of this service
 * @member {Array.<module:model/API>} apis
 */
APIsJSON.prototype.apis = undefined;

/**
 * Maintainers of the apis.json file
 * @member {Array.<module:model/Maintainer>} maintainers
 */
APIsJSON.prototype.maintainers = undefined;

/**
 * Tags to describe the service
 * @member {Array.<module:model/Tag>} tags
 */
APIsJSON.prototype.tags = undefined;

/**
 * Links to other apis.json definitions included in this service.
 * @member {Array.<module:model/Include>} include
 */
APIsJSON.prototype.include = undefined;

