/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.51
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {Formats} from './Formats';
import {Given} from './Given';
import {Severity} from './Severity';
import {Then} from './Then';

/**
 * The Rule model module.
 * @module model/Rule
 * @version V1
 */
export class Rule {
  /**
   * Constructs a new <code>Rule</code>.
   * @alias module:model/Rule
   * @class
   * @param given {module:model/Given} 
   * @param then {Array.<module:model/Then>} 
   */
  constructor(given, then) {
    this.given = given;
    this.then = then;
  }

  /**
   * Constructs a <code>Rule</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Rule} obj Optional instance to populate.
   * @return {module:model/Rule} The populated <code>Rule</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new Rule();
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('documentationUrl'))
        obj.documentationUrl = ApiClient.convertToType(data['documentationUrl'], 'String');
      if (data.hasOwnProperty('recommended'))
        obj.recommended = ApiClient.convertToType(data['recommended'], 'Boolean');
      if (data.hasOwnProperty('given'))
        obj.given = Given.constructFromObject(data['given']);
      if (data.hasOwnProperty('resolved'))
        obj.resolved = ApiClient.convertToType(data['resolved'], 'Boolean');
      if (data.hasOwnProperty('severity'))
        obj.severity = Severity.constructFromObject(data['severity']);
      if (data.hasOwnProperty('message'))
        obj.message = ApiClient.convertToType(data['message'], 'String');
      if (data.hasOwnProperty('tags'))
        obj.tags = ApiClient.convertToType(data['tags'], ['String']);
      if (data.hasOwnProperty('formats'))
        obj.formats = Formats.constructFromObject(data['formats']);
      if (data.hasOwnProperty('then'))
        obj.then = ApiClient.convertToType(data['then'], [Then]);
      if (data.hasOwnProperty('type'))
        obj.type = ApiClient.convertToType(data['type'], 'String');
      if (data.hasOwnProperty('extensions'))
        obj.extensions = ApiClient.convertToType(data['extensions'], Object);
    }
    return obj;
  }
}

/**
 * @member {String} description
 */
Rule.prototype.description = undefined;

/**
 * @member {String} documentationUrl
 */
Rule.prototype.documentationUrl = undefined;

/**
 * @member {Boolean} recommended
 */
Rule.prototype.recommended = undefined;

/**
 * @member {module:model/Given} given
 */
Rule.prototype.given = undefined;

/**
 * @member {Boolean} resolved
 */
Rule.prototype.resolved = undefined;

/**
 * @member {module:model/Severity} severity
 */
Rule.prototype.severity = undefined;

/**
 * @member {String} message
 */
Rule.prototype.message = undefined;

/**
 * @member {Array.<String>} tags
 */
Rule.prototype.tags = undefined;

/**
 * @member {module:model/Formats} formats
 */
Rule.prototype.formats = undefined;

/**
 * @member {Array.<module:model/Then>} then
 */
Rule.prototype.then = undefined;

/**
 * Allowed values for the <code>type</code> property.
 * @enum {String}
 * @readonly
 */
Rule.TypeEnum = {
  /**
   * value: "style"
   * @const
   */
  style: "style",

  /**
   * value: "validation"
   * @const
   */
  validation: "validation"
};
/**
 * @member {module:model/Rule.TypeEnum} type
 */
Rule.prototype.type = undefined;

/**
 * @member {Object} extensions
 */
Rule.prototype.extensions = undefined;

