/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.51
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {SearchLinks} from './SearchLinks';
import {SearchMeta} from './SearchMeta';

/**
 * The Search model module.
 * @module model/Search
 * @version V1
 */
export class Search {
  /**
   * Constructs a new <code>Search</code>.
   * An JSON API object with metadata, data, and links.
   * @alias module:model/Search
   * @class
   * @param meta {module:model/SearchMeta} 
   * @param data {Array.<Object>} Listing of APIs in the JSON API format.
   * @param links {module:model/SearchLinks} 
   */
  constructor(meta, data, links) {
    this.meta = meta;
    this.data = data;
    this.links = links;
  }

  /**
   * Constructs a <code>Search</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Search} obj Optional instance to populate.
   * @return {module:model/Search} The populated <code>Search</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new Search();
      if (data.hasOwnProperty('meta'))
        obj.meta = SearchMeta.constructFromObject(data['meta']);
      if (data.hasOwnProperty('data'))
        obj.data = ApiClient.convertToType(data['data'], [AnyOfSearchDataItems]);
      if (data.hasOwnProperty('links'))
        obj.links = SearchLinks.constructFromObject(data['links']);
    }
    return obj;
  }
}

/**
 * @member {module:model/SearchMeta} meta
 */
Search.prototype.meta = undefined;

/**
 * Listing of APIs in the JSON API format.
 * @member {Array.<Object>} data
 */
Search.prototype.data = undefined;

/**
 * @member {module:model/SearchLinks} links
 */
Search.prototype.links = undefined;

